/* Problem URL: https://codeforces.com/problemset/problem/2125/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    ll mod = 998244353;

    auto fastpow = [&](ll a, ll p) {
        ll ans = 1;
        ll now = a;

        rep(i, 30) {
            if ((p >> i) & 1) {
                ans *= now;
                ans %= mod;
            }

            now *= now;
            now %= mod;
        }

        return ans;
    };

    if (m > 1) {
        m = 1 << (32 - __builtin_clz(m - 1));
    }

    vl lazy(m * 2);
    V<pair<ll, ll>> seg(m * 2);

    auto propagate = [&](int i) {
        if (lazy[i] == 0) {
            return;
        }

        ll npos = ((1 - lazy[i]) % mod + mod) % mod;
        seg[i].first = ((seg[i].first + lazy[i] - seg[i].first * lazy[i]) % mod + mod) % mod;
        seg[i].second = (seg[i].second * npos) % mod;

        if (i >= m) {
            return;
        }
    };
    
    function<void(int, int, int, int, int, ll)> update = [&](int i, int l, int r, int tl, int tr, ll v) {
        propagate(i);
        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazy[i] = v;
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, v);
    };

    while (n--) {

    }
}
